extends MarginContainer
## Menu allowing the user to adjust game configuration.

const SETTINGS_GROUP := "Settings"
const SETTINGS_FILE := "override.cfg"


func _get_settings_elements() -> Array[Setting]:
	var elements: Array[Setting] = []
	elements.assign(get_tree().get_nodes_in_group(SETTINGS_GROUP))
	return elements


## Close menu without applying settings.
func cancel() -> void:
	queue_free()


## Apply all settings.
func apply() -> void:
	for setting: Setting in _get_settings_elements():
		setting.apply()


## Write all applied settings to disk.
func save_settings() -> void:
	ProjectSettings.save_custom(SETTINGS_FILE)


## Apply settings and close menu.
func accept() -> void:
	apply()
	save_settings()
	queue_free()
